﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Gurock.SmartInspect;

namespace DojoNorthSoftware.WindowsServerSolutions.HomeServerSMART2013.Components
{
    public class SmartDefinitions
    {
        private SmartHddDefinitions hddDefinitions;
        private SmartSsdIndilinxDefinitions ssdIndilinxDefinitions;
        private SmartSsdEverestDefinitions ssdEverestDefinitions;
        private SmartSsdBarefoot3Definitions ssdBarefoot3Definitions;
        private SmartSsdLamdDefinitions ssdLamdDefinitions;
        private SmartSsdIntelDefinitions ssdIntelDefinitions;
        private SmartSsdJMicronDefinitions ssdJMicronDefinitions;
        private SmartSsdMarvellDefinitions ssdMarvellDefinitions;
        private SmartSsdMicronDefinitions ssdMicronDefinitions;
        private SmartSsdSandForceDefinitions ssdSandForceDefinitions;
        private SmartSsdSamsungDefinitions ssdSamsungDefinitions;
        private SmartSsdSmartModularDefinitions ssdSmartModularDefinitions;
        private SmartSsdStecDefinitions ssdSmartStecDefinitions;
        private SmartSsdGenericDefinitions ssdSmartGenericDefinitions;

        public SmartDefinitions()
        {
            SiAuto.Main.EnterMethod("HomeServerSMART2013.Components.SmartDefinitions.SmartDefinitions");
            SiAuto.Main.LogMessage("[SMART Definitions] Construct HDD definitions.");
            hddDefinitions = new SmartHddDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Indilinx definitions."); 
            ssdIndilinxDefinitions = new SmartSsdIndilinxDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Indilinx Everest definitions."); 
            ssdEverestDefinitions = new SmartSsdEverestDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Indilinx Barefoot 3 definitions.");
            ssdBarefoot3Definitions = new SmartSsdBarefoot3Definitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Intel definitions.");
            ssdIntelDefinitions = new SmartSsdIntelDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - JMicron definitions.");
            ssdJMicronDefinitions = new SmartSsdJMicronDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Marvell definitions.");
            ssdMarvellDefinitions = new SmartSsdMarvellDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Micron definitions.");
            ssdMicronDefinitions = new SmartSsdMicronDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Samsung definitions.");
            ssdSamsungDefinitions = new SmartSsdSamsungDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - SandForce definitions."); 
            ssdSandForceDefinitions = new SmartSsdSandForceDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - SMART Modular definitions.");
            ssdSmartModularDefinitions = new SmartSsdSmartModularDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - STEC definitions.");
            ssdSmartStecDefinitions = new SmartSsdStecDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - LAMD definitions.");
            ssdLamdDefinitions = new SmartSsdLamdDefinitions();
            SiAuto.Main.LogMessage("[SMART Definitions] Construct SSD - Generic definitions.");
            ssdSmartGenericDefinitions = new SmartSsdGenericDefinitions();
            
            SiAuto.Main.LeaveMethod("HomeServerSMART2013.Components.SmartDefinitions.SmartDefinitions");
        }

        public SmartHddDefinitions HddDefinitions
        {
            get
            {
                return hddDefinitions;
            }
        }

        public SmartSsdIndilinxDefinitions SsdIndilinxDefinitions
        {
            get
            {
                return ssdIndilinxDefinitions;
            }
        }

        public SmartSsdEverestDefinitions SsdEverestDefinitions
        {
            get
            {
                return ssdEverestDefinitions;
            }
        }

        public SmartSsdBarefoot3Definitions SsdBarefoot3Definitions
        {
            get
            {
                return ssdBarefoot3Definitions;
            }
        }

        public SmartSsdLamdDefinitions SsdLamdDefinitions
        {
            get
            {
                return ssdLamdDefinitions;
            }
        }

        public SmartSsdIntelDefinitions SsdIntelDefinitions
        {
            get
            {
                return ssdIntelDefinitions;
            }
        }

        public SmartSsdJMicronDefinitions SsdJMicronDefinitions
        {
            get
            {
                return ssdJMicronDefinitions;
            }
        }

        public SmartSsdMarvellDefinitions SsdMarvellDefinitions
        {
            get
            {
                return ssdMarvellDefinitions;
            }
        }

        public SmartSsdMicronDefinitions SsdMicronDefinitions
        {
            get
            {
                return ssdMicronDefinitions;
            }
        }

        public SmartSsdSandForceDefinitions SsdSandForceDefinitions
        {
            get
            {
                return ssdSandForceDefinitions;
            }
        }

        public SmartSsdSamsungDefinitions SsdSamsungDefinitions
        {
            get
            {
                return ssdSamsungDefinitions;
            }
        }

        public SmartSsdSmartModularDefinitions SsdSmartModularDefinitions
        {
            get
            {
                return ssdSmartModularDefinitions;
            }
        }

        public SmartSsdStecDefinitions SsdStecDefinitions
        {
            get
            {
                return ssdSmartStecDefinitions;
            }
        }

        public SmartSsdGenericDefinitions SsdGenericDefinitions
        {
            get
            {
                return ssdSmartGenericDefinitions;
            }
        }
    }
}
