﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DojoNorthSoftware.WindowsServerSolutions.HomeServerSMART2013.UI.BitLocker
{
    public enum BitLockerVolumeStatus : uint
    {
        S_OK = 0x0,
        S_FALSE = 0x1,
        ERROR_CERT_FILE_NOT_FOUND = 0x2,
        ERROR_INVALID_DATA_BLVERSION = 0xD,
        ERROR_INVALID_OPERATION = 0x10DD,
        E_INVALIDARG_BLVERSION = 0xCCD802F,
        ERROR_FILE_NOT_FOUND = 0x80070002,
        ERROR_PATH_NOT_FOUND = 0x80070003,
        ERROR_INVALID_DATA = 0x8007000D,
        E_ACCESS_DENIED = 0x80070005,
        E_INVALIDARG = 0x80070057,
        ERROR_DISK_FULL = 0x80070070,
        ERROR_ELEMENT_NOT_FOUND = 0x80070490,
        E_CANNOT_ESCROW_KEY_TO_ACTIVE_DIRECTORY = 0x8007054B,
        ERROR_INVALID_OPERATION2 = 0x800710DD,
        NTE_BAD_KEYSET = 0x80090016,
        NTE_KEYSET_NOT_DEFINED = 0x80090019,
        NTE_SILENT_CONTEXT = 0x80090022,
        CRYPT_E_NO_KEY_PROPERTY = 0x8009200B,
        TBS_E_SERVICE_NOT_RUNNING = 0x80284008,
        // SCARD (Smart Card) specific errors
        SCARD_E_SYSTEM_CANCELLED = 0x80100012,
        SCARD_F_COMM_ERROR = 0x80100013,
        SCARD_F_UNKNOWN_ERROR = 0x80100014,
        SCARD_E_READER_UNAVAILABLE = 0x80100017,
        SCARD_P_SHUTDOWN = 0x80100018,
        SCARD_E_NO_SERVICE = 0x8010001D,
        SCARD_E_SERVICE_STOPPED = 0x8010001E,
        SCARD_E_UNEXPECTED = 0x8010001F,
        SCARD_E_NO_SUCH_CERTIFICATE = 0x8010002C,
        SCARD_E_CERTIFICATE_UNAVAILABLE = 0x8010002D,
        SCARD_E_NO_READERS_AVAILABLE = 0x8010002E,
        SCARD_E_COMM_DATA_LOST = 0x8010002F,
        SCARD_E_NO_KEY_CONTAINER = 0x80100030,
        SCARD_E_SERVER_TOO_BUSY = 0x80100031,
        SCARD_E_PIN_CACHE_EXPIRED = 0x80100032,
        SCARD_E_NO_PIN_CACHE = 0x80100033,
        // FVE (full volume encryption aka BitLocker) specific errors
        FVE_E_LOCKED_VOLUME = 0x80310000,
        FVE_E_NOT_ENCRYPTED = 0x80310001,
        FVE_E_NO_TPM_BIOS = 0x80310002,
        FVE_E_NO_MBR_METRIC = 0x80310003,
        FVE_E_NO_BOOTSECTOR_METRIC = 0x80310004,
        FVE_E_NO_BOOTMGR_METRIC = 0x80310005,
        FVE_E_WRONG_BOOTMGR = 0x80310006,
        FVE_E_SECURE_KEY_REQUIRED = 0x80310007,
        FVE_E_NOT_ACTIVATED = 0x80310008,
        FVE_E_ACTION_NOT_ALLOWED = 0x80310009,
        FVE_E_AD_SCHEMA_NOT_INSTALLED = 0x8031000A,
        FVE_E_AD_INVALID_DATATYPE = 0x8031000B,
        FVE_E_AD_INVALID_DATASIZE = 0x8031000C,
        FVE_E_AD_NO_VALUES = 0x8031000D,
        FVE_E_AD_ATTR_NOT_SET = 0x8031000E,
        FVE_E_AD_GUID_NOT_FOUND = 0x8031000F,
        FVE_E_BAD_INFORMATION = 0x80310010,
        FVE_E_TOO_SMALL = 0x80310011,
        FVE_E_SYSTEM_VOLUME = 0x80310012,
        FVE_E_FAILED_WRONG_FS = 0x80310013,
        FVE_E_BAD_PARTITION_SIZE = 0x80310014,
        FVE_E_NOT_SUPPORTED = 0x80310015,
        FVE_E_BAD_DATA = 0x80310016,
        FVE_E_VOLUME_NOT_BOUND = 0x80310017,
        FVE_E_TPM_NOT_OWNED = 0x80310018,
        FVE_E_NOT_DATA_VOLUME = 0x80310019,
        FVE_E_AD_INSUFFICIENT_BUFFER = 0x8031001A,
        FVE_E_CONV_READ = 0x8031001B,
        FVE_E_CONV_WRITE = 0x8031001C,
        FVE_E_KEY_REQUIRED = 0x8031001D,
        FVE_E_CLUSTERING_NOT_SUPPORTED = 0x8031001E,
        FVE_E_VOLUME_BOUND_ALREADY = 0x8031001F,
        FVE_E_OS_NOT_PROTECTED = 0x80310020,
        FVE_E_PROTECTION_DISABLED = 0x80310021,
        FVE_E_RECOVERY_KEY_REQUIRED = 0x80310022,
        FVE_E_FOREIGN_VOLUME = 0x80310023,
        FVE_E_OVERLAPPED_UPDATE = 0x80310024,
        FVE_E_TPM_SRK_AUTH_NOT_ZERO = 0x80310025,
        FVE_E_FAILED_SECTOR_SIZE = 0x80310026,
        FVE_E_FAILED_AUTHENTICATION = 0x80310027,
        FVE_E_NOT_OS_VOLUME = 0x80310028,
        FVE_E_AUTOUNLOCK_ENABLED = 0x80310029,
        FVE_E_WRONG_BOOTSECTOR = 0x8031002A,
        FVE_E_WRONG_SYSTEM_FS = 0x8031002B,
        FVE_E_POLICY_PASSWORD_REQUIRED = 0x8031002C,
        FVE_E_CANNOT_SET_FVEK_ENCRYPTED = 0x8031002D,
        FVE_E_CANNOT_ENCRYPT_NO_KEY = 0x8031002E,
        FVE_E_BOOTABLE_CDDVD = 0x80310030,
        FVE_E_PROTECTOR_EXISTS = 0x80310031,
        FVE_E_RELATIVE_PATH = 0x80310032,
        FVE_E_PROTECTOR_NOT_FOUND = 0x80310033,
        FVE_E_INVALID_KEY_FORMAT = 0x80310034,
        FVE_E_INVALID_PASSWORD_FORMAT = 0x80310035,
        FVE_E_FIPS_RNG_CHECK_FAILED = 0x80310036,
        FVE_E_FIPS_PREVENTS_RECOVERY_PASSWORD = 0x80310037,
        FVE_E_FIPS_PREVENTS_EXTERNAL_KEY_EXPORT = 0x80310038,
        FVE_E_NOT_DECRYPTED = 0x80310039,
        FVE_E_INVALID_PROTECTOR_TYPE = 0x8031003A,
        FVE_E_NO_PROTECTORS_TO_TEST = 0x8031003B,
        FVE_E_KEYFILE_NOT_FOUND = 0x8031003C,
        FVE_E_KEYFILE_INVALID = 0x8031003D,
        FVE_E_KEYFILE_NO_VMK = 0x8031003E,
        FVE_E_TPM_DISABLED = 0x8031003F,
        FVE_E_NOT_ALLOWED_IN_SAFE_MODE = 0x80310040,
        FVE_E_TPM_INVALID_PCR = 0x80310041,
        FVE_E_TPM_NO_VMK = 0x80310042,
        FVE_E_PIN_INVALID = 0x80310043,
        FVE_E_AUTH_INVALID_APPLICATION = 0x80310044,
        FVE_E_AUTH_INVALID_CONFIG = 0x80310045,
        FVE_E_FIPS_DISABLE_PROTECTION_NOT_ALLOWED = 0x80310046,
        FVE_E_FS_NOT_EXTENDED = 0x80310047,
        FVE_E_FIRMWARE_TYPE_NOT_SUPPORTED = 0x80310048,
        FVE_E_NO_LICENSE = 0x80310049,
        FVE_E_NOT_ON_STACK = 0x8031004A,
        FVE_E_FS_MOUNTED = 0x8031004B,
        FVE_E_TOKEN_NOT_IMPERSONATED = 0x8031004C,
        FVE_E_DRY_RUN_FAILED = 0x8031004D,
        FVE_E_REBOOT_REQUIRED = 0x8031004E,
        FVE_E_DEBUGGER_ENABLED = 0x8031004F,
        FVE_E_RAW_ACCESS = 0x80310050,
        FVE_E_RAW_BLOCKED = 0x80310051,
        FVE_E_BCD_APPLICATIONS_PATH_INCORRECT = 0x80310052,
        FVE_E_NOT_ALLOWED_IN_VERSION = 0x80310053,
        FVE_E_NO_AUTOUNLOCK_MASTER_KEY = 0x80310054,
        FVE_E_MOR_FAILED = 0x80310055,
        FVE_E_HIDDEN_VOLUME = 0x80310056,
        FVE_E_TRANSIENT_STATE = 0x80310057,
        FVE_E_PUBKEY_NOT_ALLOWED = 0x80310058,
        FVE_E_VOLUME_HANDLE_OPEN = 0x80310059,
        FVE_E_NO_FEATURE_LICENSE = 0x8031005A,
        FVE_E_INVALID_STARTUP_OPTIONS = 0x8031005B,
        FVE_E_POLICY_RECOVERY_PASSWORD_NOT_ALLOWED = 0x8031005C,
        FVE_E_POLICY_RECOVERY_PASSWORD_REQUIRED = 0x8031005D,
        FVE_E_POLICY_RECOVERY_KEY_NOT_ALLOWED = 0x8031005E,
        FVE_E_POLICY_RECOVERY_KEY_REQUIRED = 0x8031005F,
        FVE_E_POLICY_STARTUP_PIN_NOT_ALLOWED = 0x80310060,
        FVE_E_POLICY_STARTUP_PIN_REQUIRED = 0x80310061,
        FVE_E_POLICY_STARTUP_KEY_NOT_ALLOWED = 0x80310062,
        FVE_E_POLICY_STARTUP_KEY_REQUIRED = 0x80310063,
        FVE_E_POLICY_STARTUP_PIN_KEY_NOT_ALLOWED = 0x80310064,
        FVE_E_POLICY_STARTUP_PIN_KEY_REQUIRED = 0x80310065,
        FVE_E_POLICY_STARTUP_TPM_NOT_ALLOWED = 0x80310066,
        FVE_E_POLICY_STARTUP_TPM_REQUIRED = 0x80310067,
        FVE_E_POLICY_INVALID_PIN_LENGTH = 0x80310068,
        FVE_E_KEY_PROTECTOR_NOT_SUPPORTED = 0x80310069,
        FVE_E_POLICY_PASSPHRASE_NOT_ALLOWED = 0x8031006A,
        FVE_E_POLICY_PASSPHRASE_REQUIRED = 0x8031006B,
        FVE_E_FIPS_PREVENTS_PASSPHRASE = 0x8031006C,
        FVE_E_OS_VOLUME_PASSPHRASE_NOT_ALLOWED = 0x8031006D,
        FVE_E_INVALID_BITLOCKER_OID = 0x8031006E,
        FVE_E_VOLUME_TOO_SMALL = 0x8031006F,
        FVE_E_DV_NOT_SUPPORTED_ON_FS = 0x80310070,
        FVE_E_DV_NOT_ALLOWED_BY_GP = 0x80310071,
        FVE_E_POLICY_USER_CERTIFICATE_NOT_ALLOWED = 0x80310072,
        FVE_E_POLICY_USER_CERTIFICATE_REQUIRED = 0x80310073,
        FVE_E_POLICY_USER_CERT_MUST_BE_HW = 0x80310074,
        FVE_E_POLICY_USER_CONFIGURE_FDV_AUTOUNLOCK_NOT_ALLOWED = 0x80310075,
        FVE_E_POLICY_USER_CONFIGURE_RDV_AUTOUNLOCK_NOT_ALLOWED = 0x80310076,
        FVE_E_POLICY_USER_CONFIGURE_RDV_NOT_ALLOWED = 0x80310077,
        FVE_E_POLICY_USER_ENABLE_RDV_NOT_ALLOWED = 0x80310078,
        FVE_E_POLICY_USER_DISABLE_RDV_NOT_ALLOWED = 0x80310079,
        FVE_E_POLICY_INVALID_PASSPHRASE_LENGTH = 0x80310080,
        FVE_E_POLICY_PASSPHRASE_TOO_SIMPLE = 0x80310081,
        FVE_E_RECOVERY_PARTITION = 0x80310082,
        FVE_E_POLICY_CONFLICT_FDV_RK_OFF_AUK_ON = 0x80310083,
        FVE_E_POLICY_CONFLICT_RDV_RK_OFF_AUK_ON = 0x80310084,
        FVE_E_NON_BITLOCKER_OID = 0x80310085,
        FVE_E_POLICY_PROHIBITS_SELFSIGNED = 0x80310086,
        FVE_E_POLICY_CONFLICT_RO_AND_STARTUP_KEY_REQUIRED = 0x80310087,
        FVE_E_CONV_RECOVERY_FAILED = 0x80310088,
        FVE_E_VIRTUALIZED_SPACE_TOO_BIG = 0x80310089,
        FVE_E_POLICY_CONFLICT_OSV_RP_OFF_ADB_ON = 0x80310090,
        FVE_E_POLICY_CONFLICT_FDV_RP_OFF_ADB_ON = 0x80310091,
        FVE_E_POLICY_CONFLICT_RDV_RP_OFF_ADB_ON = 0x80310092,
        FVE_E_NON_BITLOCKER_KU = 0x80310093,
        FVE_E_PRIVATEKEY_AUTH_FAILED = 0x80310094,
        FVE_E_REMOVAL_OF_DRA_FAILED = 0x80310095,
        FVE_E_OPERATION_NOT_SUPPORTED_ON_VISTA_VOLUME = 0x80310096,
        FVE_E_CANT_LOCK_AUTOUNLOCK_ENABLED_VOLUME = 0x80310097,
        FVE_E_FIPS_HASH_KDF_NOT_ALLOWED = 0x80310098,
        FVE_E_INVALID_PIN_CHARS = 0x8031009A
    }

    public enum EncryptionState : uint
    {
        FULLY_DECRYPTED = 0,
        FULLY_ENCRYPTED = 1,
        ENCRYPTION_IN_PROGRESS = 2,
        DECRYPTION_IN_PROGRESS = 3,
        ENCRYPTION_PAUSED = 4,
        DECRYPTION_PAUSED = 5
    }

    public enum EncryptionMethod : uint
    {
        DEFAULT_METHOD = 0,
        AES_128_DIFFUSER = 1,
        AES_256_DIFFUSER = 2,
        AES_128 = 3,
        AES_256 = 4
    }

    public enum KeyProtectorTypes : uint
    {
        ALL_TYPES = 0,
        TRUSTED_PLATFORM_MODULE = 1,
        EXTERNAL_KEY = 2,
        NUMERIC_PASSWORD = 3,
        TPM_AND_PIN = 4,
        TPM_AND_STARTUP_KEY = 5,
        TPM_AND_PIN_AND_STARTUP_KEY = 6,
        PUBLIC_KEY = 7,
        PASSPHRASE = 8
    }

    public enum MetadataVersion : uint
    {
        VERSION_UNKNOWN = 0,
        VERSION_VISTA = 1,
        VERSION_WIN7 = 2,
        NOT_ENCRYPTED = 65535
    }

    public enum LicenseStatus : uint
    {
        LICENSE_TRIAL = 0,
        LICENSE_ACTIVATED = 1,
        LICENSE_ACTIVATION_FAILED = 2,
        LICENSE_EXPIRED = 3
    }

    public enum DiskType : uint
    {
        DISK_SYSTEM = 0,
        DISK_FIXED_DATA = 1,
        DISK_ROAMING_DATA = 2,
        DISK_UNKNOWN = 3
    }

    public enum ShutDown
    {
        LogOff = 0,
        Shutdown = 1,
        Reboot = 2,
        ForcedLogOff = 4,
        ForcedShutdown = 5,
        ForcedReboot = 6,
        PowerOff = 8,
        ForcedPowerOff = 12
    }
}
